
INCLUDE "c:\program files\scenix\includes\sx18.inc"

;
;  Sample ASM file to test Chuck's Assembler.
;
;  tests of specific processor functions
;

v0          equ      0x00
v10         equ      'A'
v11         equ      0x11
v12         equ      0x12
v13         equ      0x13
v14         equ      0x14
v15         equ      0x15
v16         equ      0x16
v17         equ      0x17
v18         equ      0x18
v19         equ      0x19
v1a         equ      0x1A
v1b         equ      0x1B
v1c         equ      0x1C
v1d         equ      0x1D
v1e         equ      0x1E
v1f         equ      0x1F
vf0         equ      $F0
vf1         equ      0xF1
vf2         equ      0xF2
vf3         equ      0xF3
vf4         equ      0xF4
vf5         equ      0xF5
vf6         equ      0xF6
vf7         equ      0xF7
vf8         equ      0xF8
vf9         equ      0xF9
vfa         equ      0xFA
vfb         equ      0xFB
vfc         equ      0xFC
vfd         equ      0xFD
vfe         equ      0xFE
vff         equ      H'FF'


            org      $000
Interrupt
            movlw    $92
            andlw    $92
            xorlw    $92
            iorlw    $92
            reti


Start
            movlw    $00
            bank     7              ; test upper bank RAM
            movwf    vff
Loop1                               ;
            mode     7
            movfw    vff
            iread
            movwf    vf1
            movmw
            movwf    vf0
            incf     vff
            bcf      STATUS, Z
            testf    vf1
            btfss    STATUS, Z      ; loop until lower 8 bits from iread is 0
            goto     Loop1

Stuck
            goto     Stuck


            org      $700   ; table in PM, to test IREAD function
            mem      'H'
            mem      'e'
            mem      'l'
            mem      'l'
            mem      'o'
            mem      ' '
            mem      'W'
            mem      'o'
            mem      'r'
            mem      'l'
            mem      'd'
            mem      $000

            org      $7FF
Reset
            goto     Start


